using System;
using System.Diagnostics;
using System.Windows.Forms;
using System.ComponentModel;
using System.Reflection;
using System.IO;
using System.Runtime.InteropServices;
using System.Drawing;
using System.Collections;
using System.Data;
using Microsoft.Win32;

namespace Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		internal System.Windows.Forms.TextBox txtBarcodeInfo;
		internal System.Windows.Forms.Button btnOpen;
		internal System.Windows.Forms.OpenFileDialog OFD;
		internal System.Windows.Forms.Button btnScan;
		internal System.Windows.Forms.Button btnClose;
		internal System.Windows.Forms.GroupBox GroupBox2;
		internal System.Windows.Forms.Button btnImageInfo;
		internal System.Windows.Forms.TextBox txtRHeight;
		internal System.Windows.Forms.TextBox txtRWidth;
		internal System.Windows.Forms.TextBox txtRTop;
		internal System.Windows.Forms.TextBox txtRLeft;
		internal System.Windows.Forms.ComboBox cbxPages;
		internal System.Windows.Forms.TextBox txtPages;
		internal System.Windows.Forms.TextBox txtHeight;
		internal System.Windows.Forms.TextBox txtWidth;
		internal System.Windows.Forms.Label Label21;
		internal System.Windows.Forms.Label Label20;
		internal System.Windows.Forms.Label Label19;
		internal System.Windows.Forms.Label Label18;
		internal System.Windows.Forms.Label Label17;
		internal System.Windows.Forms.Label Label16;
		internal System.Windows.Forms.Label Label15;
		internal System.Windows.Forms.Label Label14;
		internal System.Windows.Forms.GroupBox GroupBox1;
		internal System.Windows.Forms.Button btnScanningOptions;
		internal System.Windows.Forms.ComboBox cbxMaxBarHeight;
		internal System.Windows.Forms.ComboBox cbxMinBarHeight;
		internal System.Windows.Forms.ComboBox cbxQuietZone;
		internal System.Windows.Forms.CheckBox chkIT25;
		internal System.Windows.Forms.CheckBox chkUPCE;
		internal System.Windows.Forms.CheckBox chkUPCA;
		internal System.Windows.Forms.CheckBox chkEAN8;
		internal System.Windows.Forms.CheckBox chkEAN13;
		internal System.Windows.Forms.CheckBox chkEAN128;
		internal System.Windows.Forms.CheckBox chkCode128;
		internal System.Windows.Forms.CheckBox chkCode39;
		internal System.Windows.Forms.Label Label12;
		internal System.Windows.Forms.Label Label11;
		internal System.Windows.Forms.Label Label10;
		internal System.Windows.Forms.Label Label9;
		internal System.Windows.Forms.Label Label8;
		internal System.Windows.Forms.Label Label7;
		internal System.Windows.Forms.Label Label6;
		internal System.Windows.Forms.Label Label5;
		internal System.Windows.Forms.Label Label4;
		internal System.Windows.Forms.Label Label3;
		internal System.Windows.Forms.Label Label2;
		internal System.Windows.Forms.Label Label1;
		internal System.Windows.Forms.TextBox txtThreshold;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Variables
			bool	 bEAN8;
			bool	 bEAN13;
			bool	 bIT25;
			bool	 bUPCE;
			bool	 bUPCA;
			bool	 bEAN128;
			bool	 bCode128;
			bool	 bCode39;
			int		 nThreshold = 128;
			float	 fQuietZone = 10;
			float	 fMinBarHeight = 1;
			float	 fMaxBarHeight = 5;

			int		 nImgFormat;
			int		 nPageOption;
			int		 nRLeft;
			int		 nRTop;
			int		 nRRight;
			int		 nRBottom;
			int		 nImgWidth;
			int		 nImgHeight;
		#endregion

		#region DLL Imports
		[DllImport("kernel32.dll", CharSet=CharSet.Auto)]
		static extern IntPtr LoadLibrary(string lpFileNmae);

		[DllImport("Decode1D.dll")] public static extern int De1DInit();

		[DllImport("Decode1D.dll")] public static extern int De1DSetkey(string Key);

		[DllImport("Decode1D.dll")] public static extern int De1DCleanUp();
    
		[DllImport("Decode1D.dll")] public static extern int De1DGetCount();
    
		[DllImport("Decode1D.dll")] public static extern int De1DGetType(int CodeIndex);
    
		[DllImport("Decode1D.dll")] public static extern int De1DGetStrLen(int CodeIndex);
    
		[DllImport("Decode1D.dll")] public static extern byte De1DGetCharAt(int CodeIndex, int CharIndex);
    
		[DllImport("Decode1D.dll")] public static extern int De1DGetRect(int CodeIndex, ref long P1, ref long P2, ref long P3, ref long P4);
    
		[DllImport("Decode1D.dll")] public static extern int De1DLoadFromMem(byte[] Buffer, long Size, int ImgFormat);
    
		[DllImport("Decode1D.dll")] public static extern int De1DLoadFromFile(string FileName, int ImgFormat);

		[DllImport("Decode1D.dll")] public static extern int De1DSetKey(string Key);
    
		[DllImport("Decode1D.dll")] public static extern int De1DGetNumOfPages();

		[DllImport("Decode1D.dll")] public static extern int De1DSetPage(int PageIndex);

		[DllImport("Decode1D.dll")] public static extern int De1DGetImgSize(ref int Width, ref int Height);

		[DllImport("Decode1D.dll")] public static extern int De1DSetThreshold(int Threshold);
    
		[DllImport("Decode1D.dll")] public static extern int De1DSetRegion(int Left, int Top, int Right, int Bottom);
    
		[DllImport("Decode1D.dll")] public static extern int De1DSetLimit(double QuietZoneSize, double MinBarHeight, double MaxBarHeight);
    
		[DllImport("Decode1D.dll")] public static extern int De1DScanType(int CodeType, int Enabled);
    
		[DllImport("Decode1D.dll")] public static extern int De1DScan();
		#endregion
    
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.txtBarcodeInfo = new System.Windows.Forms.TextBox();
			this.btnOpen = new System.Windows.Forms.Button();
			this.OFD = new System.Windows.Forms.OpenFileDialog();
			this.btnScan = new System.Windows.Forms.Button();
			this.btnClose = new System.Windows.Forms.Button();
			this.GroupBox2 = new System.Windows.Forms.GroupBox();
			this.btnImageInfo = new System.Windows.Forms.Button();
			this.txtRHeight = new System.Windows.Forms.TextBox();
			this.txtRWidth = new System.Windows.Forms.TextBox();
			this.txtRTop = new System.Windows.Forms.TextBox();
			this.txtRLeft = new System.Windows.Forms.TextBox();
			this.cbxPages = new System.Windows.Forms.ComboBox();
			this.txtPages = new System.Windows.Forms.TextBox();
			this.txtHeight = new System.Windows.Forms.TextBox();
			this.txtWidth = new System.Windows.Forms.TextBox();
			this.Label21 = new System.Windows.Forms.Label();
			this.Label20 = new System.Windows.Forms.Label();
			this.Label19 = new System.Windows.Forms.Label();
			this.Label18 = new System.Windows.Forms.Label();
			this.Label17 = new System.Windows.Forms.Label();
			this.Label16 = new System.Windows.Forms.Label();
			this.Label15 = new System.Windows.Forms.Label();
			this.Label14 = new System.Windows.Forms.Label();
			this.GroupBox1 = new System.Windows.Forms.GroupBox();
			this.btnScanningOptions = new System.Windows.Forms.Button();
			this.cbxMaxBarHeight = new System.Windows.Forms.ComboBox();
			this.cbxMinBarHeight = new System.Windows.Forms.ComboBox();
			this.cbxQuietZone = new System.Windows.Forms.ComboBox();
			this.chkIT25 = new System.Windows.Forms.CheckBox();
			this.chkUPCE = new System.Windows.Forms.CheckBox();
			this.chkUPCA = new System.Windows.Forms.CheckBox();
			this.chkEAN8 = new System.Windows.Forms.CheckBox();
			this.chkEAN13 = new System.Windows.Forms.CheckBox();
			this.chkEAN128 = new System.Windows.Forms.CheckBox();
			this.chkCode128 = new System.Windows.Forms.CheckBox();
			this.chkCode39 = new System.Windows.Forms.CheckBox();
			this.Label12 = new System.Windows.Forms.Label();
			this.Label11 = new System.Windows.Forms.Label();
			this.Label10 = new System.Windows.Forms.Label();
			this.Label9 = new System.Windows.Forms.Label();
			this.Label8 = new System.Windows.Forms.Label();
			this.Label7 = new System.Windows.Forms.Label();
			this.Label6 = new System.Windows.Forms.Label();
			this.Label5 = new System.Windows.Forms.Label();
			this.Label4 = new System.Windows.Forms.Label();
			this.Label3 = new System.Windows.Forms.Label();
			this.Label2 = new System.Windows.Forms.Label();
			this.Label1 = new System.Windows.Forms.Label();
			this.txtThreshold = new System.Windows.Forms.TextBox();
			this.GroupBox2.SuspendLayout();
			this.GroupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// txtBarcodeInfo
			// 
			this.txtBarcodeInfo.Location = new System.Drawing.Point(443, 21);
			this.txtBarcodeInfo.Multiline = true;
			this.txtBarcodeInfo.Name = "txtBarcodeInfo";
			this.txtBarcodeInfo.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.txtBarcodeInfo.Size = new System.Drawing.Size(171, 408);
			this.txtBarcodeInfo.TabIndex = 7;
			this.txtBarcodeInfo.Text = "";
			// 
			// btnOpen
			// 
			this.btnOpen.Location = new System.Drawing.Point(273, 321);
			this.btnOpen.Name = "btnOpen";
			this.btnOpen.Size = new System.Drawing.Size(128, 24);
			this.btnOpen.TabIndex = 3;
			this.btnOpen.Text = "Open An Image File";
			this.btnOpen.Click += new System.EventHandler(this.btnOpen_Click);
			// 
			// btnScan
			// 
			this.btnScan.Location = new System.Drawing.Point(273, 361);
			this.btnScan.Name = "btnScan";
			this.btnScan.Size = new System.Drawing.Size(128, 24);
			this.btnScan.TabIndex = 6;
			this.btnScan.Text = "Scan It";
			this.btnScan.Click += new System.EventHandler(this.btnScan_Click);
			// 
			// btnClose
			// 
			this.btnClose.Location = new System.Drawing.Point(273, 401);
			this.btnClose.Name = "btnClose";
			this.btnClose.Size = new System.Drawing.Size(128, 24);
			this.btnClose.TabIndex = 8;
			this.btnClose.Text = "Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// GroupBox2
			// 
			this.GroupBox2.Controls.Add(this.btnImageInfo);
			this.GroupBox2.Controls.Add(this.txtRHeight);
			this.GroupBox2.Controls.Add(this.txtRWidth);
			this.GroupBox2.Controls.Add(this.txtRTop);
			this.GroupBox2.Controls.Add(this.txtRLeft);
			this.GroupBox2.Controls.Add(this.cbxPages);
			this.GroupBox2.Controls.Add(this.txtPages);
			this.GroupBox2.Controls.Add(this.txtHeight);
			this.GroupBox2.Controls.Add(this.txtWidth);
			this.GroupBox2.Controls.Add(this.Label21);
			this.GroupBox2.Controls.Add(this.Label20);
			this.GroupBox2.Controls.Add(this.Label19);
			this.GroupBox2.Controls.Add(this.Label18);
			this.GroupBox2.Controls.Add(this.Label17);
			this.GroupBox2.Controls.Add(this.Label16);
			this.GroupBox2.Controls.Add(this.Label15);
			this.GroupBox2.Controls.Add(this.Label14);
			this.GroupBox2.Location = new System.Drawing.Point(248, 15);
			this.GroupBox2.Name = "GroupBox2";
			this.GroupBox2.Size = new System.Drawing.Size(174, 297);
			this.GroupBox2.TabIndex = 5;
			this.GroupBox2.TabStop = false;
			this.GroupBox2.Text = "Image Info";
			// 
			// btnImageInfo
			// 
			this.btnImageInfo.Enabled = false;
			this.btnImageInfo.Location = new System.Drawing.Point(49, 256);
			this.btnImageInfo.Name = "btnImageInfo";
			this.btnImageInfo.Size = new System.Drawing.Size(80, 32);
			this.btnImageInfo.TabIndex = 4;
			this.btnImageInfo.Text = "Apply";
			this.btnImageInfo.Click += new System.EventHandler(this.btnImageInfo_Click);
			// 
			// txtRHeight
			// 
			this.txtRHeight.Location = new System.Drawing.Point(96, 223);
			this.txtRHeight.Name = "txtRHeight";
			this.txtRHeight.Size = new System.Drawing.Size(64, 20);
			this.txtRHeight.TabIndex = 3;
			this.txtRHeight.Text = "";
			// 
			// txtRWidth
			// 
			this.txtRWidth.Location = new System.Drawing.Point(96, 195);
			this.txtRWidth.Name = "txtRWidth";
			this.txtRWidth.Size = new System.Drawing.Size(64, 20);
			this.txtRWidth.TabIndex = 2;
			this.txtRWidth.Text = "";
			// 
			// txtRTop
			// 
			this.txtRTop.Location = new System.Drawing.Point(96, 167);
			this.txtRTop.Name = "txtRTop";
			this.txtRTop.Size = new System.Drawing.Size(64, 20);
			this.txtRTop.TabIndex = 1;
			this.txtRTop.Text = "";
			// 
			// txtRLeft
			// 
			this.txtRLeft.Location = new System.Drawing.Point(96, 139);
			this.txtRLeft.Name = "txtRLeft";
			this.txtRLeft.Size = new System.Drawing.Size(64, 20);
			this.txtRLeft.TabIndex = 0;
			this.txtRLeft.Text = "";
			// 
			// cbxPages
			// 
			this.cbxPages.Location = new System.Drawing.Point(96, 110);
			this.cbxPages.Name = "cbxPages";
			this.cbxPages.Size = new System.Drawing.Size(64, 21);
			this.cbxPages.TabIndex = 15;
			this.cbxPages.SelectedIndexChanged += new System.EventHandler(this.cbxPages_SelectedIndexChanged);
			// 
			// txtPages
			// 
			this.txtPages.Enabled = false;
			this.txtPages.Location = new System.Drawing.Point(96, 81);
			this.txtPages.Name = "txtPages";
			this.txtPages.Size = new System.Drawing.Size(64, 20);
			this.txtPages.TabIndex = 10;
			this.txtPages.Text = "";
			// 
			// txtHeight
			// 
			this.txtHeight.Enabled = false;
			this.txtHeight.Location = new System.Drawing.Point(96, 53);
			this.txtHeight.Name = "txtHeight";
			this.txtHeight.Size = new System.Drawing.Size(64, 20);
			this.txtHeight.TabIndex = 9;
			this.txtHeight.Text = "";
			// 
			// txtWidth
			// 
			this.txtWidth.Enabled = false;
			this.txtWidth.Location = new System.Drawing.Point(96, 25);
			this.txtWidth.Name = "txtWidth";
			this.txtWidth.Size = new System.Drawing.Size(64, 20);
			this.txtWidth.TabIndex = 8;
			this.txtWidth.Text = "";
			// 
			// Label21
			// 
			this.Label21.Location = new System.Drawing.Point(8, 227);
			this.Label21.Name = "Label21";
			this.Label21.Size = new System.Drawing.Size(78, 18);
			this.Label21.TabIndex = 7;
			this.Label21.Text = "Region Height";
			// 
			// Label20
			// 
			this.Label20.Location = new System.Drawing.Point(8, 198);
			this.Label20.Name = "Label20";
			this.Label20.Size = new System.Drawing.Size(78, 18);
			this.Label20.TabIndex = 6;
			this.Label20.Text = "Region Width";
			// 
			// Label19
			// 
			this.Label19.Location = new System.Drawing.Point(8, 169);
			this.Label19.Name = "Label19";
			this.Label19.Size = new System.Drawing.Size(69, 18);
			this.Label19.TabIndex = 5;
			this.Label19.Text = "Region Top";
			// 
			// Label18
			// 
			this.Label18.Location = new System.Drawing.Point(8, 140);
			this.Label18.Name = "Label18";
			this.Label18.Size = new System.Drawing.Size(69, 18);
			this.Label18.TabIndex = 4;
			this.Label18.Text = "Region Left";
			// 
			// Label17
			// 
			this.Label17.Location = new System.Drawing.Point(8, 111);
			this.Label17.Name = "Label17";
			this.Label17.Size = new System.Drawing.Size(87, 18);
			this.Label17.TabIndex = 3;
			this.Label17.Text = "Choose A Page";
			// 
			// Label16
			// 
			this.Label16.Location = new System.Drawing.Point(8, 82);
			this.Label16.Name = "Label16";
			this.Label16.Size = new System.Drawing.Size(48, 18);
			this.Label16.TabIndex = 2;
			this.Label16.Text = "Pages";
			// 
			// Label15
			// 
			this.Label15.Location = new System.Drawing.Point(8, 53);
			this.Label15.Name = "Label15";
			this.Label15.Size = new System.Drawing.Size(48, 18);
			this.Label15.TabIndex = 1;
			this.Label15.Text = "Height";
			// 
			// Label14
			// 
			this.Label14.Location = new System.Drawing.Point(8, 24);
			this.Label14.Name = "Label14";
			this.Label14.Size = new System.Drawing.Size(48, 18);
			this.Label14.TabIndex = 0;
			this.Label14.Text = "Width";
			// 
			// GroupBox1
			// 
			this.GroupBox1.Controls.Add(this.btnScanningOptions);
			this.GroupBox1.Controls.Add(this.cbxMaxBarHeight);
			this.GroupBox1.Controls.Add(this.cbxMinBarHeight);
			this.GroupBox1.Controls.Add(this.cbxQuietZone);
			this.GroupBox1.Controls.Add(this.chkIT25);
			this.GroupBox1.Controls.Add(this.chkUPCE);
			this.GroupBox1.Controls.Add(this.chkUPCA);
			this.GroupBox1.Controls.Add(this.chkEAN8);
			this.GroupBox1.Controls.Add(this.chkEAN13);
			this.GroupBox1.Controls.Add(this.chkEAN128);
			this.GroupBox1.Controls.Add(this.chkCode128);
			this.GroupBox1.Controls.Add(this.chkCode39);
			this.GroupBox1.Controls.Add(this.Label12);
			this.GroupBox1.Controls.Add(this.Label11);
			this.GroupBox1.Controls.Add(this.Label10);
			this.GroupBox1.Controls.Add(this.Label9);
			this.GroupBox1.Controls.Add(this.Label8);
			this.GroupBox1.Controls.Add(this.Label7);
			this.GroupBox1.Controls.Add(this.Label6);
			this.GroupBox1.Controls.Add(this.Label5);
			this.GroupBox1.Controls.Add(this.Label4);
			this.GroupBox1.Controls.Add(this.Label3);
			this.GroupBox1.Controls.Add(this.Label2);
			this.GroupBox1.Controls.Add(this.Label1);
			this.GroupBox1.Controls.Add(this.txtThreshold);
			this.GroupBox1.Location = new System.Drawing.Point(18, 16);
			this.GroupBox1.Name = "GroupBox1";
			this.GroupBox1.Size = new System.Drawing.Size(216, 416);
			this.GroupBox1.TabIndex = 4;
			this.GroupBox1.TabStop = false;
			this.GroupBox1.Text = "Scanning Options";
			// 
			// btnScanningOptions
			// 
			this.btnScanningOptions.Location = new System.Drawing.Point(71, 359);
			this.btnScanningOptions.Name = "btnScanningOptions";
			this.btnScanningOptions.Size = new System.Drawing.Size(80, 32);
			this.btnScanningOptions.TabIndex = 13;
			this.btnScanningOptions.Text = "Apply";
			this.btnScanningOptions.Click += new System.EventHandler(this.btnScanningOptions_Click);
			// 
			// cbxMaxBarHeight
			// 
			this.cbxMaxBarHeight.Items.AddRange(new object[] {
																 "5",
																 "6",
																 "7",
																 "8",
																 "9"});
			this.cbxMaxBarHeight.Location = new System.Drawing.Point(135, 306);
			this.cbxMaxBarHeight.Name = "cbxMaxBarHeight";
			this.cbxMaxBarHeight.Size = new System.Drawing.Size(64, 21);
			this.cbxMaxBarHeight.TabIndex = 11;
			// 
			// cbxMinBarHeight
			// 
			this.cbxMinBarHeight.Items.AddRange(new object[] {
																 "1",
																 "2",
																 "3",
																 "4"});
			this.cbxMinBarHeight.Location = new System.Drawing.Point(136, 279);
			this.cbxMinBarHeight.Name = "cbxMinBarHeight";
			this.cbxMinBarHeight.Size = new System.Drawing.Size(64, 21);
			this.cbxMinBarHeight.TabIndex = 10;
			// 
			// cbxQuietZone
			// 
			this.cbxQuietZone.Items.AddRange(new object[] {
															  "5",
															  "10",
															  "15",
															  "20"});
			this.cbxQuietZone.Location = new System.Drawing.Point(136, 255);
			this.cbxQuietZone.Name = "cbxQuietZone";
			this.cbxQuietZone.Size = new System.Drawing.Size(64, 21);
			this.cbxQuietZone.TabIndex = 9;
			// 
			// chkIT25
			// 
			this.chkIT25.Checked = true;
			this.chkIT25.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkIT25.Location = new System.Drawing.Point(136, 204);
			this.chkIT25.Name = "chkIT25";
			this.chkIT25.Size = new System.Drawing.Size(16, 22);
			this.chkIT25.TabIndex = 7;
			// 
			// chkUPCE
			// 
			this.chkUPCE.Checked = true;
			this.chkUPCE.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkUPCE.Location = new System.Drawing.Point(136, 177);
			this.chkUPCE.Name = "chkUPCE";
			this.chkUPCE.Size = new System.Drawing.Size(16, 22);
			this.chkUPCE.TabIndex = 6;
			// 
			// chkUPCA
			// 
			this.chkUPCA.Checked = true;
			this.chkUPCA.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkUPCA.Location = new System.Drawing.Point(136, 150);
			this.chkUPCA.Name = "chkUPCA";
			this.chkUPCA.Size = new System.Drawing.Size(16, 22);
			this.chkUPCA.TabIndex = 5;
			// 
			// chkEAN8
			// 
			this.chkEAN8.Checked = true;
			this.chkEAN8.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkEAN8.Location = new System.Drawing.Point(136, 126);
			this.chkEAN8.Name = "chkEAN8";
			this.chkEAN8.Size = new System.Drawing.Size(16, 22);
			this.chkEAN8.TabIndex = 4;
			// 
			// chkEAN13
			// 
			this.chkEAN13.Checked = true;
			this.chkEAN13.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkEAN13.Location = new System.Drawing.Point(136, 99);
			this.chkEAN13.Name = "chkEAN13";
			this.chkEAN13.Size = new System.Drawing.Size(16, 22);
			this.chkEAN13.TabIndex = 3;
			// 
			// chkEAN128
			// 
			this.chkEAN128.Checked = true;
			this.chkEAN128.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkEAN128.Location = new System.Drawing.Point(136, 72);
			this.chkEAN128.Name = "chkEAN128";
			this.chkEAN128.Size = new System.Drawing.Size(16, 22);
			this.chkEAN128.TabIndex = 2;
			// 
			// chkCode128
			// 
			this.chkCode128.Checked = true;
			this.chkCode128.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkCode128.Location = new System.Drawing.Point(136, 48);
			this.chkCode128.Name = "chkCode128";
			this.chkCode128.Size = new System.Drawing.Size(16, 22);
			this.chkCode128.TabIndex = 1;
			// 
			// chkCode39
			// 
			this.chkCode39.Checked = true;
			this.chkCode39.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chkCode39.Location = new System.Drawing.Point(136, 21);
			this.chkCode39.Name = "chkCode39";
			this.chkCode39.Size = new System.Drawing.Size(16, 22);
			this.chkCode39.TabIndex = 0;
			// 
			// Label12
			// 
			this.Label12.Location = new System.Drawing.Point(10, 310);
			this.Label12.Name = "Label12";
			this.Label12.Size = new System.Drawing.Size(120, 16);
			this.Label12.TabIndex = 11;
			this.Label12.Text = "Max Bar Height in CMs";
			// 
			// Label11
			// 
			this.Label11.Location = new System.Drawing.Point(10, 284);
			this.Label11.Name = "Label11";
			this.Label11.Size = new System.Drawing.Size(120, 16);
			this.Label11.TabIndex = 10;
			this.Label11.Text = "Min Bar Height in CMs";
			// 
			// Label10
			// 
			this.Label10.Location = new System.Drawing.Point(10, 258);
			this.Label10.Name = "Label10";
			this.Label10.Size = new System.Drawing.Size(120, 16);
			this.Label10.TabIndex = 9;
			this.Label10.Text = "Quiet Zone";
			// 
			// Label9
			// 
			this.Label9.Location = new System.Drawing.Point(10, 232);
			this.Label9.Name = "Label9";
			this.Label9.Size = new System.Drawing.Size(120, 16);
			this.Label9.TabIndex = 8;
			this.Label9.Text = "Threshold";
			// 
			// Label8
			// 
			this.Label8.Location = new System.Drawing.Point(10, 206);
			this.Label8.Name = "Label8";
			this.Label8.Size = new System.Drawing.Size(112, 16);
			this.Label8.TabIndex = 7;
			this.Label8.Text = "Check Interleaved 25";
			// 
			// Label7
			// 
			this.Label7.Location = new System.Drawing.Point(10, 180);
			this.Label7.Name = "Label7";
			this.Label7.Size = new System.Drawing.Size(112, 16);
			this.Label7.TabIndex = 6;
			this.Label7.Text = "Check UPCE";
			// 
			// Label6
			// 
			this.Label6.Location = new System.Drawing.Point(10, 154);
			this.Label6.Name = "Label6";
			this.Label6.Size = new System.Drawing.Size(112, 16);
			this.Label6.TabIndex = 5;
			this.Label6.Text = "Check UPCA";
			// 
			// Label5
			// 
			this.Label5.Location = new System.Drawing.Point(10, 128);
			this.Label5.Name = "Label5";
			this.Label5.Size = new System.Drawing.Size(112, 16);
			this.Label5.TabIndex = 4;
			this.Label5.Text = "Check EAN8";
			// 
			// Label4
			// 
			this.Label4.Location = new System.Drawing.Point(10, 102);
			this.Label4.Name = "Label4";
			this.Label4.Size = new System.Drawing.Size(112, 16);
			this.Label4.TabIndex = 3;
			this.Label4.Text = "Check EAN13";
			// 
			// Label3
			// 
			this.Label3.Location = new System.Drawing.Point(10, 76);
			this.Label3.Name = "Label3";
			this.Label3.Size = new System.Drawing.Size(112, 16);
			this.Label3.TabIndex = 2;
			this.Label3.Text = "Check EAN128";
			// 
			// Label2
			// 
			this.Label2.Location = new System.Drawing.Point(10, 50);
			this.Label2.Name = "Label2";
			this.Label2.Size = new System.Drawing.Size(112, 16);
			this.Label2.TabIndex = 1;
			this.Label2.Text = "Check Code128";
			// 
			// Label1
			// 
			this.Label1.Location = new System.Drawing.Point(10, 24);
			this.Label1.Name = "Label1";
			this.Label1.Size = new System.Drawing.Size(112, 16);
			this.Label1.TabIndex = 0;
			this.Label1.Text = "Check Code39";
			// 
			// txtThreshold
			// 
			this.txtThreshold.Location = new System.Drawing.Point(136, 231);
			this.txtThreshold.Name = "txtThreshold";
			this.txtThreshold.Size = new System.Drawing.Size(56, 20);
			this.txtThreshold.TabIndex = 8;
			this.txtThreshold.Text = "128";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 446);
			this.Controls.Add(this.btnOpen);
			this.Controls.Add(this.btnScan);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.GroupBox2);
			this.Controls.Add(this.GroupBox1);
			this.Controls.Add(this.txtBarcodeInfo);
			this.Name = "Form1";
			this.Text = "Demo";
			this.Load += new System.EventHandler(this.Form1_Load);
			this.Closed += new System.EventHandler(this.Form1_Closed);
			this.GroupBox2.ResumeLayout(false);
			this.GroupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

			Init_GUI();
		}

		private void Init_GUI()
		{
			chkCode39.Checked = true;
			chkCode128.Checked = true;
			chkEAN128.Checked = true;
			chkEAN13.Checked = true;
			chkEAN8.Checked = true;
			chkUPCA.Checked = true;
			chkUPCE.Checked = true;
			chkIT25.Checked = true;
			txtThreshold.Text = "128";
			cbxQuietZone.SelectedIndex = 1;
			cbxMinBarHeight.SelectedIndex = 0;
			cbxMaxBarHeight.SelectedIndex = 0;

			bCode39 = true; 
			bCode128 = true; 
			bEAN128 = true; 
			bEAN13 = true; 
			bEAN8 = true; 
			bUPCA = true; 
			bUPCE = true; 
			bIT25 = true; 
			nThreshold = 128;
			fQuietZone = 10;
			fMinBarHeight = 1;
			fMaxBarHeight = 5;
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			//Environment.CurrentDirectory = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location);

			string WinDir = System.Environment.GetEnvironmentVariable("WinDir");
			string DLLPath = WinDir + "\\System32\\Decode1D.dll";
			LoadLibrary(DLLPath);

			Application.Run(new Form1());
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private int GetImgFormat(string ImgName)
		{
			// get the extension part of a file name
			int pos = ImgName.IndexOf(".");
			string ext_name = ImgName.Substring(pos + 1, ImgName.Length - pos - 1);
			ext_name = ext_name.ToLower();

			if (ext_name.CompareTo("bmp") == 0)
				return 1;
			else if (ext_name.CompareTo("gif") == 0)
				return 2;
			else if (ext_name.CompareTo("ico") == 0)
				return 3;
			else if (ext_name.CompareTo("jpg") == 0)
				return 4;
			else if (ext_name.CompareTo("png") == 0)
				return 5;
			else if ((ext_name.CompareTo("tif") == 0) || (ext_name.CompareTo("tiff") == 0))
				return 6;
			else if (ext_name.CompareTo("wmf") == 0)
				return 7;
			else
				return -1;

		}

		private void btnScan_Click(object sender, System.EventArgs e)
		{
			// enable/disable scanning Code39
			if (bCode39)
				De1DScanType(0, 1);
			else
				De1DScanType(0, 0);

			// enable/disable scanning Code128
			if (bCode128)
				De1DScanType(1, 1);
			else
				De1DScanType(1, 0);

			// enable/disable scanning EAN128
			if (bEAN128)
				De1DScanType(2, 1);
			else
				De1DScanType(2, 0);

			// enable/disable scanning EAN13
			if (bEAN13)
				De1DScanType(3, 1);
			else
				De1DScanType(3, 0);

			// enable/disable scanning EAN8
			if (bEAN8)
				De1DScanType(4, 1);
			else
				De1DScanType(4, 0);

			// enable/disable scanning UPCA
			if (bUPCA)
				De1DScanType(5, 1);
			else
				De1DScanType(5, 0);

			// enable/disable scanning UPCE
			if (bUPCE)
				De1DScanType(6, 1);
			else
				De1DScanType(6, 0);

			// enable/disable scanning Interleaved 25
			if (bIT25)
				De1DScanType(7, 1);
			else
				De1DScanType(7, 0);

			// For full version library, pass the 10-digit license key to this function
			// Sample code:
			// result = De1DSetKey("123456-7890");
			De1DSetKey("DEMO");

			De1DSetThreshold(nThreshold);

			De1DSetLimit(fQuietZone, fMinBarHeight, fMaxBarHeight);

			De1DSetRegion(nRLeft, nRTop, nRRight, nRBottom);

			De1DScan();

			int count = De1DGetCount() & 0xFF;

			if (count > 0)
			{
				string BarcodeInfo;
				int type;
				if (count == 1)
					BarcodeInfo = "1 Barcode Found\r\n";
				else
					BarcodeInfo = System.Convert.ToString(count) + " Barcodes Found\r\n";

				for(int i = 1; i <= count; i++)
				{
					BarcodeInfo = BarcodeInfo + "[Barcode " + System.Convert.ToString(i) + "]\r\n";

					// barcode type
					type = De1DGetType(i - 1);
					if (type == 0)
						BarcodeInfo = BarcodeInfo + "Type: Code39\r\n";
					else if (type == 1)
						BarcodeInfo = BarcodeInfo + "Type: Code128\r\n";
					else if (type == 2)
						BarcodeInfo = BarcodeInfo + "Type: EAN128\r\n";
					else if (type == 3)
						BarcodeInfo = BarcodeInfo + "Type: EAN13\r\n";
					else if (type == 4)
						BarcodeInfo = BarcodeInfo + "Type: EAN8\r\n";
					else if (type == 5)
						BarcodeInfo = BarcodeInfo + "Type: UPCA\r\n";
					else if (type == 6)
						BarcodeInfo = BarcodeInfo + "Type: UPCE\r\n";
					else if (type == 7)
						BarcodeInfo = BarcodeInfo + "Type: Interleaved 25\r\n";

					// barcode boundary rectangle
					long[] P = new long[4];
					De1DGetRect(i - 1, ref P[0], ref P[1], ref P[2], ref P[3]);
					for (int j = 1; j <= 4; j++)
					{
						BarcodeInfo = BarcodeInfo + "Point " + System.Convert.ToString(j) + ": ";
						BarcodeInfo = BarcodeInfo + "(" + System.Convert.ToString((P[j - 1] >> 16) & 0xFFFF) + ", ";
						BarcodeInfo = BarcodeInfo + System.Convert.ToString(P[j - 1] & 0xFFFF) + ")" + "\r\n";
					}

					// a string encoded by this barcode
					int len = De1DGetStrLen(i - 1);
					BarcodeInfo = BarcodeInfo + "String length:" + System.Convert.ToString(len) + "\r\n";
					BarcodeInfo = BarcodeInfo + "String:";
					for (int j = 0; j < len; j++)
					{
						int ch = De1DGetCharAt(i - 1, j);
						if ((type == 1 || type == 2) &&
							(ch >= 201) && (ch <= 204))
							// code128 or EAN128
							// FNC 1, FNC 2, FNC 3 or FNC 4
							BarcodeInfo = BarcodeInfo + "FNC " + System.Convert.ToChar(ch - 200 + 48);
						else
							BarcodeInfo = BarcodeInfo + System.Convert.ToChar(ch);
					}
					BarcodeInfo = BarcodeInfo + "\r\n\r\n";
				}
				txtBarcodeInfo.Text = BarcodeInfo;
			}
			else
			{
				txtBarcodeInfo.Text = "No barcode found.";
			}
		}

		private void btnOpen_Click(object sender, System.EventArgs e)
		{
			string file_name;
			int result, P;
			int w = 0;
			int h = 0;
			long i;

			// clean file name
			OFD.FileName = "";

			OFD.ShowDialog();

			file_name = OFD.FileName;

			if (file_name == null) 
				return;

			// get image format info
			nImgFormat = GetImgFormat(file_name);

			if (nImgFormat == -1) 
				// invalid image format
				return;

			// load image content into the library directly from the file on the disk
			result = De1DLoadFromFile(file_name, nImgFormat);

			if (result == 1)
			{
				// loading is OK
				if ((nImgFormat == 2) || (nImgFormat == 6))
				{
					// TIF or GIF file

					// how many pages
					P = De1DGetNumOfPages();
					txtPages.Text = System.Convert.ToString(P);
					cbxPages.Items.Clear();

					// update page list
					for (i = 0; i <= (P - 1); i++)
						cbxPages.Items.Add(System.Convert.ToString(i));

					cbxPages.SelectedIndex = 0;

					// choose 1st page
					result = De1DSetPage(0);

					if (result == 1)
					{
						// image size
						result = De1DGetImgSize(ref w, ref h);

						txtWidth.Text = System.Convert.ToString(w);
						txtRWidth.Text = System.Convert.ToString(w);

						txtHeight.Text = System.Convert.ToString(h);
						txtRHeight.Text = System.Convert.ToString(h);

						txtRLeft.Text = "0";
						txtRTop.Text = "0";

						nRLeft = 0;
						nRTop = 0;
						nRRight = w - 1;
						nRBottom = h - 1;
						nImgWidth = w;
						nImgHeight = h;
					}
				}
				else
				{
					txtPages.Text = "";
					cbxPages.Items.Clear();

					// Other image formats
					txtPages.Text = "";
					cbxPages.Items.Clear();

					// image size
					result = De1DGetImgSize(ref w, ref h);

					txtWidth.Text = System.Convert.ToString(w);
					txtRWidth.Text = System.Convert.ToString(w);

					txtHeight.Text = System.Convert.ToString(h);
					txtRHeight.Text = System.Convert.ToString(h);

					txtRLeft.Text = "0";
					txtRTop.Text = "0";

					nRLeft = 0;
					nRTop = 0;
					nRRight = w - 1;
					nRBottom = h - 1;
					nImgWidth = w;
					nImgHeight = h;
				}
				btnImageInfo.Enabled = true;
			}
			else
			{
				btnImageInfo.Enabled = false;
			}
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			De1DInit();
		}

		private void Form1_Closed(object sender, System.EventArgs e)
		{
			De1DCleanUp();
		}

		private void btnScanningOptions_Click(object sender, System.EventArgs e)
		{
			bCode39 = chkCode39.Checked ; 
			bCode128 = chkCode128.Checked; 
			bEAN128 = chkEAN128.Checked; 
			bEAN13 = chkEAN13.Checked; 
			bEAN8 = chkEAN8.Checked; 
			bUPCA = chkUPCA.Checked; 
			bUPCE = chkUPCE.Checked; 
			bIT25 = chkIT25.Checked; 

			// Threshold value
			nThreshold = System.Convert.ToInt32(txtThreshold.Text);

			// Quiet zone value
			fQuietZone = (float)System.Convert.ToInt32(cbxQuietZone.Text);

			// Minimum bar height in CMs
			fMinBarHeight = (float)System.Convert.ToInt32(cbxMinBarHeight.Text);

			// Maximum bar height in CMs
			fMaxBarHeight = (float)System.Convert.ToInt32(cbxMaxBarHeight.Text);
		}

		private void btnImageInfo_Click(object sender, System.EventArgs e)
		{
			string ErrorMsg = "";

			// Region's left value
			nRLeft = System.Convert.ToInt32(txtRLeft.Text);
			if ((nRLeft < 0) || (nRLeft >= nImgWidth))
			{
				ErrorMsg = ErrorMsg + "Left value must be between 0 and image width minus 1\r\n";
				nRLeft = 0;
			}

			// Region's top value
			nRTop = System.Convert.ToInt32(txtRTop.Text);
			if ((nRTop < 0) || (nRTop >= nImgHeight))
			{
				ErrorMsg = ErrorMsg + "Left value must be between 0 and image height minus 1\r\n";
				nRTop = 0;
			}

			// Region's right value
			nRRight = nRLeft + System.Convert.ToInt32(txtRWidth.Text) - 1;
			if ((nRRight < nRLeft) || (nRRight >= nImgWidth))
			{
				ErrorMsg = ErrorMsg + "Right value must be between left value and image width minus 1\r\n";
				nRRight = nImgWidth - 1;
			}

			// Region's bottom value
			nRBottom = nRTop + System.Convert.ToInt32(txtRHeight.Text) - 1;
			if ((nRBottom < nRTop) || (nRBottom >= nImgHeight))
			{
				ErrorMsg = ErrorMsg + "Bottom value must be between top value and image height minus 1\r\n";
				nRBottom = nImgHeight - 1;
			}

			if (ErrorMsg.Length > 0)
				MessageBox.Show(ErrorMsg);
		}

		private void cbxPages_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ((nImgFormat == 2) || (nImgFormat == 6))
			{
				int PageNo = cbxPages.SelectedIndex;

				// choose a page
				int result = De1DSetPage(PageNo);

				if (result == 1)
				{
					// image size
					int w = 0;
					int h = 0;

					result = De1DGetImgSize(ref w, ref h);

					txtWidth.Text = System.Convert.ToString(w);
					txtRWidth.Text = System.Convert.ToString(w);

					txtHeight.Text = System.Convert.ToString(h);
					txtRHeight.Text = System.Convert.ToString(h);

					txtRLeft.Text = "0";
					txtRTop.Text = "0";

					nRLeft = 0;
					nRTop = 0;
					nRRight = w - 1;
					nRBottom = h - 1;
					nImgWidth = w;
					nImgHeight = h;
				}
			}
		}
	}
}
